/*
 * Copyright (c) 2018 Samsung Electronics Co., Ltd. All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "support.h"

namespace nnfw
{
namespace support
{
namespace nnapi
{
namespace feature
{

// TODO Extract this function as utility function
// NOTE It is not a good design to access nnfw::rt::Shape nnfw_support_nnapi lib
nnfw::util::feature::Shape asFeatureShape(const nnfw::rt::Shape& shape)
{
  // NNAPI assumes the following ordering:
  //
  //  dim(0) -> N
  //  dim(1) -> H
  //  dim(2) -> W
  //  dim(3) -> C
  //
  int32_t c = nnfw::rt::getSizeOfDimension(shape, 3);
  int32_t h = nnfw::rt::getSizeOfDimension(shape, 1);
  int32_t w = nnfw::rt::getSizeOfDimension(shape, 2);

  assert(nnfw::rt::getSizeOfDimension(shape, 0) == 1);

  return nnfw::util::feature::Shape{c, h, w};
}

} // namespace feature
} // namespace nnapi
} // namespace support
} // namespace nnfw
