/*
 * Copyright (c) 2018 Samsung Electronics Co., Ltd. All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "util/tensor/IndexFormatter.h"

#include <cassert>

namespace nnfw
{
namespace util
{
namespace tensor
{

std::ostream &operator<<(std::ostream &os, const IndexFormatter &fmt)
{
  const auto rank = fmt.index().rank();

  assert(rank > 0);

  os << fmt.index().at(0);

  if (rank > 1)
  {
    for (uint32_t axis = 1; axis < rank; ++axis)
    {
      os << ", " << fmt.index().at(axis);
    }
  }

  return os;
}

} // namespace tensor
} // namespace util
} // namespace nnfw
