/*
 * Copyright (c) 2018 Samsung Electronics Co., Ltd. All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "util/tensor/Shape.h"

namespace nnfw
{
namespace util
{
namespace tensor
{

bool operator==(const Shape &lhs, const Shape &rhs)
{
  if (lhs.rank() != rhs.rank())
  {
    return false;
  }

  for (size_t axis = 0; axis < lhs.rank(); ++axis)
  {
    if(lhs.dim(axis) != rhs.dim(axis))
    {
      return false;
    }
  }

  return true;
}

} // namespace tensor
} // namespace util
} // namespace nnfw
