/*
 * Copyright (c) 2018 Samsung Electronics Co., Ltd. All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __NNFW_RT_LOGGING_H__
#define __NNFW_RT_LOGGING_H__

#include <iostream>

namespace nnfw {
namespace rt {

// TODO-NNRT Move this to proper place
class BoolConfig
{
public:
  BoolConfig(const std::string &tag, bool default_value);

public:
  bool value(void) const { return _value; }

private:
  bool _value;
};

class VLogging
{
public:
  static VLogging& access(void);
  bool enabled() const { return _enabled; }
  std::ostream& stream(void);

private:
  VLogging();

private:
  bool _enabled;
};

#define LOG(...) std::cout << std::endl
#define VLOG(...) if (VLogging::access().enabled()) \
    (VLogging::access().stream() << std::endl)
#define PLOG(...) LOG(...)
#define NYI(module) std::cout << "NYI : '" << module << "' is not supported now." << std::endl;

} // namespace rt
} // namespace nnfw

#endif // __NNFW_RT_LOGGING_H__
